import { AgmCoreModule } from "@agm/core";
import { DragDropModule } from "@angular/cdk/drag-drop";
import { ScrollingModule } from "@angular/cdk/scrolling";
import { NgModule } from "@angular/core";
import { FormsModule, ReactiveFormsModule } from "@angular/forms";
import { MatAutocompleteModule } from "@angular/material/autocomplete";
import { MatButtonModule } from "@angular/material/button";
import { MatCardModule } from "@angular/material/card";
import { MatCheckboxModule } from "@angular/material/checkbox";
import { MatNativeDateModule } from "@angular/material/core";
import { MatDatepickerModule } from "@angular/material/datepicker";
import { MatDialogModule } from "@angular/material/dialog";
import { MatDividerModule } from "@angular/material/divider";
import { MatExpansionModule } from "@angular/material/expansion";
import { MatFormFieldModule } from "@angular/material/form-field";
import { MatIconModule } from "@angular/material/icon";
import { MatInputModule } from "@angular/material/input";
import { MatListModule } from "@angular/material/list";
import { MatProgressBarModule } from "@angular/material/progress-bar";
import { MatSelectModule } from "@angular/material/select";
import { MatSidenavModule } from "@angular/material/sidenav";
import { MatSnackBarModule } from "@angular/material/snack-bar";
import { MatTableModule } from "@angular/material/table";
import { MatTabsModule } from "@angular/material/tabs";
import { MatTooltipModule } from "@angular/material/tooltip";
import { BrowserModule } from "@angular/platform-browser";
import { RouterModule } from "@angular/router";
import { AperosComponent } from "./aperos/aperos.component";
import { CompletarTareaComponent } from "./completar-tarea/completar-tarea.component";
import { EstimarTareaComponent } from "./estimar-tarea/estimar-tarea.component";
import { HomeComponent } from "./home/home.component";
import { LoginComponent } from "./login/login.component";
import { NuevaParcelaComponent } from "./nueva-parcela/nueva-parcela.component";
import { NuevatareaComponent } from "./nuevatarea/nuevatarea.component";
import { NuevoAperoComponent } from "./nuevoapero/nuevoapero.component";
import { ParcelasComponent } from "./parcelas/parcelas.component";
import { ProgessbarComponent } from "./progessbar/progessbar.component";
import { RegistroComponent } from "./registro/registro.component";
import { SnackbarComponent } from "./snackbar/snackbar.component";
import { TareaComponent } from "./tarea/tarea.component";
import { TareasComponent } from "./tareas/tareas.component";
import { VerDetallesAperoComponent } from "./ver-detalles-apero/ver-detalles-apero.component";
import { VerDetallesParcelaComponent } from "./ver-detalles-parcela/ver-detalles-parcela.component";
import { DetallesTareaComponent } from "./ver-detalles-tarea/detalles-tarea.component";
import { MatSortModule } from "@angular/material/sort";
import { VerUsuariosAgendaComponent } from "./ver-usuarios-agenda/ver-usuarios-agenda.component";
import { AddUsuarioComponent } from "./add-usuario/add-usuario.component";
import { CooperativaComponent } from "./cooperativa/cooperativa.component";
import { SociosCooperativaComponent } from "./socios-cooperativa/socios-cooperativa.component";
import { ProductosCooperativaComponent } from "./productos-cooperativa/productos-cooperativa.component";
import { VerDetallesProductoComponent } from "./ver-detalles-producto/ver-detalles-producto.component";
import { NuevoProductoComponent } from "./nuevo-producto/nuevo-producto.component";
import { UsuariosComponent } from "./usuarios/usuarios.component";
import { PipesModule } from "../pipes/pipes.module";
import { RecuperarPasswordComponent } from './recuperar-password/recuperar-password.component';

@NgModule({
  declarations: [
    LoginComponent,
    RegistroComponent,
    HomeComponent,
    TareasComponent,
    ParcelasComponent,
    TareaComponent,
    NuevatareaComponent,
    SnackbarComponent,
    DetallesTareaComponent,
    EstimarTareaComponent,
    CompletarTareaComponent,
    AperosComponent,
    NuevoAperoComponent,
    ProgessbarComponent,
    VerDetallesAperoComponent,
    NuevaParcelaComponent,
    VerDetallesParcelaComponent,
    VerUsuariosAgendaComponent,
    AddUsuarioComponent,
    CooperativaComponent,
    SociosCooperativaComponent,
    ProductosCooperativaComponent,
    VerDetallesProductoComponent,
    NuevoProductoComponent,
    UsuariosComponent,
    RecuperarPasswordComponent
  ],
  imports: [
    BrowserModule,
    FormsModule,
    ReactiveFormsModule,
    MatFormFieldModule,
    MatInputModule,
    MatButtonModule,
    MatCardModule,
    RouterModule,
    MatTabsModule,
    MatSnackBarModule,
    MatSidenavModule,
    MatDividerModule,
    MatListModule,
    MatIconModule,
    DragDropModule,
    PipesModule,
    ScrollingModule,
    MatDialogModule,
    MatSelectModule,
    MatAutocompleteModule,
    MatDatepickerModule,
    MatNativeDateModule,
    MatTableModule,
    MatTooltipModule,
    MatCheckboxModule,
    MatProgressBarModule,
    MatExpansionModule,
    AgmCoreModule.forRoot({
      apiKey: "AIzaSyD8fN1BcODzpA-sB1Lwtw86exJSIDUqu-Q"
    }),
    MatSortModule
  ],
  providers: [MatDatepickerModule],
  exports: [SnackbarComponent],
  entryComponents: [
    NuevatareaComponent,
    DetallesTareaComponent,
    EstimarTareaComponent,
    CompletarTareaComponent,
    NuevoAperoComponent,
    VerDetallesAperoComponent,
    NuevaParcelaComponent,
    VerDetallesParcelaComponent,
    AddUsuarioComponent,
    VerDetallesProductoComponent,
    NuevoProductoComponent
  ]
})
export class ComponentsModule {}
