import { Component, OnInit } from "@angular/core";
import { Usuario, Role } from "src/app/models/usuario";
import { Constantes } from "src/app/constantes";
import { Router } from "@angular/router";

@Component({
  selector: "app-home",
  templateUrl: "./home.component.html",
  styleUrls: ["./home.component.css"]
})
export class HomeComponent implements OnInit {
  usuarioLogged: Usuario;
  role_agricultor: Role;
  role_responsable_cooperativa: Role;
  role_admin: Role;

  constructor(private router: Router) {}

  ngOnInit() {
    this.usuarioLogged = JSON.parse(
      sessionStorage.getItem(Constantes.USER_LOCAL_STORAGE)
    );
    this.role_agricultor = Role.ROLE_AGRICULTOR;
    this.role_responsable_cooperativa = Role.ROLE_RESPONSABLE_COOPERATIVA;
    this.role_admin = Role.ROLE_ADMIN;
  }

  public logout() {
    this.router.navigate(["login"]);
  }
}
