import {
  AfterViewChecked,
  ChangeDetectorRef,
  Component,
  OnInit
} from "@angular/core";
import { ProgressbarService } from "src/app/services/progressbarservice.service";

@Component({
  selector: "app-progessbar",
  templateUrl: "./progessbar.component.html",
  styleUrls: ["./progessbar.component.css"]
})
export class ProgessbarComponent implements OnInit, AfterViewChecked {
  public mostrar: boolean = false;

  constructor(
    public progressBarService: ProgressbarService,
    private changeDetectorRef: ChangeDetectorRef
  ) {}

  ngOnInit() {
    this.progressBarService.mostrar.subscribe(data => {
      this.mostrar = data;
    });
  }

  ngAfterViewChecked(): void {
    this.changeDetectorRef.detectChanges();
  }
}
