import { Component, OnInit, OnDestroy } from "@angular/core";
import { SnackbarService } from "src/app/services/snackbaralerts.service";
import { MatSnackBar } from "@angular/material/snack-bar";
import { Subscription } from "rxjs";
import { Router } from "@angular/router";

@Component({
  selector: "app-snackbar",
  templateUrl: "./snackbar.component.html",
  styleUrls: ["./snackbar.component.css"]
})
export class SnackbarComponent implements OnInit, OnDestroy {
  private snackbarServiceSubscription: Subscription;
  private mensaje: string;
  private accion: string;
  private color: string;

  constructor(
    private snackbarService: SnackbarService,
    private snackBar: MatSnackBar,
    private router: Router
  ) {}

  ngOnInit() {
    this.snackbarServiceSubscription = this.snackbarService.snackbarState.subscribe(
      data => {
        this.mensaje = data.mensaje;
        this.accion = data.accion;
        this.color = data.color;
        let snackbar = this.snackBar.open(this.mensaje, this.accion, {
          panelClass: [this.color],
          duration: 2000
        });
      }
    );
  }

  ngOnDestroy(): void {
    this.snackbarServiceSubscription.unsubscribe();
  }
}
