import { Component, Inject, OnInit } from "@angular/core";
import { MAT_DIALOG_DATA } from "@angular/material/dialog";
import { EstadoTarea, Tarea } from "src/app/models/tarea";
import { tieneUbicacion } from "src/app/pipes/tiene-ubicacion.pipe";

@Component({
  selector: "app-detalles-tarea",
  templateUrl: "./detalles-tarea.component.html",
  styleUrls: ["./detalles-tarea.component.css"]
})
export class DetallesTareaComponent implements OnInit {
  constructor(@Inject(MAT_DIALOG_DATA) public tarea: Tarea) {}

  public mostrarEstimada: boolean = false;
  public mostrarCompletada: boolean = false;

  ngOnInit() {
    this.mostrarEstimada =
      this.tarea.estadoTarea === EstadoTarea.ESTIMADA ||
      this.tarea.estadoTarea === EstadoTarea.COMPLETADA;
    this.mostrarCompletada = this.tarea.estadoTarea === EstadoTarea.COMPLETADA;
  }

  public fromrealToHourMins(value: number): string {
    const horas = Math.floor(value / 1);
    const minutos = (value % 1) * 60;
    return `${horas} horas y ${Math.round(minutos)} minutos`;
  }

  public tieneUbicacion() {
    return tieneUbicacion(this.tarea.parcela);
  }
}
