import { Pipe, PipeTransform } from "@angular/core";
import { UnidadProducto } from "../models/productoempleado";

@Pipe({
  name: "arrayToString"
})
export class ArrayToStringPipe implements PipeTransform {
  transform(value: any[], args = ""): any {
    let resultado = "";
    switch (args) {
      case "productoEmpleado":
        value.forEach(item => {
          resultado = resultado.concat(
            ` ${item.nombre} (${item.cantidadUsadaHa} ${this.getUnidad(
              item.unidadProducto
            )}),`
          );
        });
        break;

      case "productoRecogido":
        value.forEach(item => {
          resultado = resultado.concat(
            ` ${item.nombre} (${item.cantidadRecogidaHa} ${this.getUnidad(
              item.unidadProducto
            )}),`
          );
        });
        break;

      default:
        value.forEach(item => {
          resultado = resultado.concat(` ${item.nombre},`);
        });
        break;
    }

    resultado = resultado.substring(0, resultado.length - 1);
    const ultimaComa = resultado.lastIndexOf(",");
    return ultimaComa !== -1
      ? resultado.substring(0, ultimaComa) +
          " y" +
          resultado.substring(ultimaComa + 1)
      : resultado;
  }

  private getUnidad(unidad: string) {
    switch (unidad) {
      case "KilosHa":
        return UnidadProducto["KilosHa"];
      case "LitrosHa":
        return UnidadProducto["LitrosHa"];
      case "ToneladasHa":
        return UnidadProducto["ToneladasHa"];
      case "UnidadesHa":
        return UnidadProducto["UnidadesHa"];
    }
  }
}
