import { Pipe, PipeTransform } from '@angular/core';
import { PrecioProducto } from '../models/precio-producto';
import { RegistroHoras } from '../models/registrohoras';

@Pipe({
  name: 'ordenarPorFecha'
})
export class OrdenarPorFechaPipe implements PipeTransform {

  transform(value: any[], ...args: string[]): any {
    if (args.includes('inverso')) {
      if (args.includes('precios')) {
        return value.sort(this.ordenarPreciosPorFechas).reverse();
      } else {
        return value.sort(this.ordenarRegistroHorasPorFechas).reverse();
      }

    } else {
      if (args.includes('precios')) {
        return value.sort(this.ordenarPreciosPorFechas)
      } else {
        return value.sort(this.ordenarRegistroHorasPorFechas)
      }
    }
  }

  private ordenarPreciosPorFechas(a: PrecioProducto, b: PrecioProducto): number {
    return a.identificador - b.identificador;
  }


  private ordenarRegistroHorasPorFechas(a: RegistroHoras, b: RegistroHoras): number {
    const dateA = new Date(a.fecha);
    const dateB = new Date(b.fecha)
    return dateA.getTime() - dateB.getTime();
  }

}