import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { environment } from 'src/environments/environment';
import { Usuario } from '../models/usuario';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class PrivateAdministradorService {

  constructor(private http: HttpClient) { }

  private url = `${environment.apiUrl}/private/usuarios`

  public getUsuarios(): Observable<Usuario[]> {
    return this.http.get<Usuario[]>(this.url);
  }

  public modificarUsuario(usuario: Usuario): Observable<Usuario> {
    const endPointUrl = `${this.url}/${usuario.identificador}`;
    return this.http.put<Usuario>(endPointUrl, usuario);
  }
}
