import { Injectable } from "@angular/core";
import {
  ActivatedRouteSnapshot,
  CanActivateChild,
  RouterStateSnapshot,
  Router
} from "@angular/router";
import { Constantes } from "../constantes";
import { Usuario } from "../models/usuario";

@Injectable({
  providedIn: "root"
})
export class CanActivateAdminGuard implements CanActivateChild {
  constructor(private router: Router) {}

  canActivateChild(
    next: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
  ): boolean {
    const userLogged: Usuario = JSON.parse(
      sessionStorage.getItem(Constantes.USER_LOCAL_STORAGE)
    );
    if (userLogged.rol === "ROLE_ADMIN") {
      return true;
    } else {
      this.router.navigate["/login"];
      return false;
    }
  }
}
