import { Injectable } from "@angular/core";
import {
  ActivatedRouteSnapshot,
  RouterStateSnapshot,
  UrlTree,
  CanActivateChild,
  Router
} from "@angular/router";
import { Usuario } from "../models/usuario";
import { Constantes } from "../constantes";

@Injectable({
  providedIn: "root"
})
export class CanActivateAgricultorGuard implements CanActivateChild {
  constructor(private router: Router) {}

  canActivateChild(
    childRoute: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
  ): boolean {
    const userLogged: Usuario = JSON.parse(
      sessionStorage.getItem(Constantes.USER_LOCAL_STORAGE)
    );
    if (userLogged.rol === "ROLE_AGRICULTOR") {
      return true;
    } else {
      this.router.navigate(["/login"]);
      return false;
    }
  }
}
