import { Injectable } from '@angular/core';
import { CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot, UrlTree, Router } from '@angular/router';
import { of, Observable } from 'rxjs';
import { Constantes } from '../constantes';

@Injectable()
export class CanActivateUsuarioLoggedService implements CanActivate {
  canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean | UrlTree | Observable<boolean | UrlTree> | Promise<boolean | UrlTree> {

    const token: string = sessionStorage.getItem(Constantes.TOKEN_LOCAL_STORAGE);
    if (!(token === null)) {
      return true;
    } else {
      this.router.navigate(['/login'])
    }
  }

  constructor(private router: Router) { }
}
