package com.tfg.gestiontareas.api;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonView;
import com.tfg.gestiontareas.model.TipoLabor;
import com.tfg.gestiontareas.repository.IRepoTipoLabor;
import com.tfg.gestiontareas.util.Views;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/private/tiposLabor")
public class PrivateTiposLaborController {

    @Autowired
    private IRepoTipoLabor iRepoTipoLabor;

    @JsonView(Views.ListView.class)
    @GetMapping(value = "")
    public ResponseEntity<List<TipoLabor>> getTodas() {
        List<TipoLabor> tiposLabor = iRepoTipoLabor.findAll();
        return new ResponseEntity<List<TipoLabor>>(tiposLabor, HttpStatus.OK);
    }

    @PostMapping(value = "")
    public ResponseEntity<TipoLabor> nuevoTipoLabor(@RequestBody TipoLabor entity) {
        TipoLabor registrada = iRepoTipoLabor.save(entity);
        return new ResponseEntity<TipoLabor>(registrada, HttpStatus.CREATED);
    }

}