package com.tfg.gestiontareas.api;

import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

import com.fasterxml.jackson.annotation.JsonView;
import com.tfg.gestiontareas.model.EnumRole;
import com.tfg.gestiontareas.model.Usuario;
import com.tfg.gestiontareas.repository.IRepoUsuario;
import com.tfg.gestiontareas.util.Views;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/private/usuarios")
public class PrivateUsuariosController {

    @Autowired
    private IRepoUsuario iRepoUsuario;

    @JsonView(Views.AdminUsersListView.class)
    @GetMapping
    public ResponseEntity<List<Usuario>> getUsuarios() {

        List<Usuario> usuarios = iRepoUsuario.findAll();
        usuarios = usuarios.stream().filter(usuario -> usuario.getRol() != EnumRole.ROLE_ADMIN)
                .collect(Collectors.toList());
        return new ResponseEntity<>(usuarios, HttpStatus.OK);
    }

    @JsonView(Views.AdminUsersListView.class)
    @PutMapping(value = "/{id}")
    public ResponseEntity<?> bloquearUsuario(@PathVariable Long id, @RequestBody Usuario entity) {
        Optional<Usuario> usuario = iRepoUsuario.findById(id);
        if (usuario.isPresent()) {
            Usuario usuarioGet = usuario.get();
            usuarioGet.setBloqueado(entity.isBloqueado());
            Usuario registrado = iRepoUsuario.save(usuarioGet);
            return new ResponseEntity<>(registrado, HttpStatus.OK);
        } else {
            return new ResponseEntity<>("No se ha encontrado el usuario con ese id", HttpStatus.NOT_FOUND);
        }
    }

}