package com.tfg.gestiontareas.model;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonView;
import com.tfg.gestiontareas.util.Views;

@Entity(name = "Aperos")
public class Apero {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false, updatable = false)
    @JsonView(Views.ListView.class)
    private Long identificador;

    @Column(name = "marca", nullable = false)
    @JsonView(Views.ListView.class)
    private String marca;

    @Column(name = "modelo", nullable = false)
    @JsonView(Views.ListView.class)
    private String modelo;

    @JsonView(Views.ListView.class)
    @Column(name = "matricula", nullable = true)
    private String matricula;

    @JsonView(Views.ListView.class)
    @Column(name = "descripcion", nullable = true)
    private String descripcion;

    @Column(name = "costePorHa", nullable = false)
    @JsonView(Views.ListView.class)
    private Float costePorHa;

    @ManyToOne(optional = false)
    @JsonView(Views.ListView.class)
    private UsuarioAgricultor propietario;

    @ManyToMany(fetch = FetchType.EAGER)
    @JoinTable(name = "rel_apero_tipo_labor", joinColumns = @JoinColumn(name = "apero"), inverseJoinColumns = @JoinColumn(name = "tipoLabor"))
    @JsonView(Views.ListView.class)
    private Set<TipoLabor> tipoLabores;

    @OneToMany(mappedBy = "apero", orphanRemoval = true, fetch = FetchType.EAGER)
    @JsonIgnore
    private Set<Tarea> tareas;

    public Apero() {

    }

    public Long getIdentificador() {
        return identificador;
    }

    public String getMarca() {
        return marca;
    }

    public void setMarca(String marca) {
        this.marca = marca;
    }

    public String getModelo() {
        return modelo;
    }

    public void setModelo(String modelo) {
        this.modelo = modelo;
    }

    public String getMatricula() {
        return matricula;
    }

    public void setMatricula(String matricula) {
        this.matricula = matricula;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public Float getCostePorHa() {
        return costePorHa;
    }

    public void setCostePorHa(Float costePorHa) {
        this.costePorHa = costePorHa;
    }

    public void setIdentificador(Long identificador) {
        this.identificador = identificador;
    }

    public UsuarioAgricultor getPropietario() {
        return propietario;
    }

    public void setPropietario(UsuarioAgricultor propietario) {
        this.propietario = propietario;
    }

    public Set<TipoLabor> getTipoLabores() {
        return tipoLabores;
    }

    public void setTipoLabores(Set<TipoLabor> tipoLabores) {
        this.tipoLabores = tipoLabores;
    }

    public Set<Tarea> getTareas() {
        return tareas;
    }

    public void setTareas(Set<Tarea> tareasAsignadas) {
        this.tareas = tareasAsignadas;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Apero) {
            if (((Apero) obj).getIdentificador().equals(identificador)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

}
