package com.tfg.gestiontareas.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity(name = "PreciosProductos")
public class PrecioProducto {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false, updatable = false)
    private Long identificador;

    @Column(name = "precio", nullable = false)
    private Float precio;

    @Column(name = "fechaCreacion", nullable = false)
    private Date fechaCreacion;

    @ManyToOne(optional = false)
    @JsonIgnore
    private ProductoCooperativa productoCooperativa;

    public PrecioProducto() {

    }

    public Long getIdentificador() {
        return identificador;
    }

    public Float getPrecio() {
        return precio;
    }

    public void setPrecio(Float precio) {
        this.precio = precio;
    }

    public Date getFechaCreacion() {
        return fechaCreacion;
    }

    public void setFechaCreacion(Date fechaCreacion) {
        this.fechaCreacion = fechaCreacion;
    }

    public ProductoCooperativa getProductoCooperativa() {
        return productoCooperativa;
    }

    public void setProductoCooperativa(ProductoCooperativa productoCooperativa) {
        this.productoCooperativa = productoCooperativa;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof PrecioProducto) {
            if (((PrecioProducto) obj).getIdentificador().equals(identificador)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

}
