package com.tfg.gestiontareas.model;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonView;
import com.tfg.gestiontareas.util.Views;

@Entity(name = "TiposLabores")
public class TipoLabor {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false, updatable = false)
    @JsonView(Views.ListView.class)
    private Long identificador;

    @Column(name = "nombre", nullable = false)
    @JsonView(Views.ListView.class)
    private String nombre;

    @Column(name = "descripcion", nullable = false)
    @JsonView(Views.ListView.class)
    private String descripcion;

    @Column(name = "necesitaProducto", nullable = false)
    @JsonView(Views.ListView.class)
    private boolean necesitaProducto;

    @Column(name = "recolectaProducto", nullable = false)
    @JsonView(Views.ListView.class)
    private boolean recolectaProducto;

    @ManyToMany(mappedBy = "tipoLabores")
    @JsonIgnore
    private Set<Apero> aperos;

    @OneToMany(mappedBy = "tipoLabor", orphanRemoval = true)
    @JsonIgnore
    private Set<Tarea> tareas;

    public TipoLabor() {

    }

    public Long getIdentificador() {
        return identificador;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public boolean isNecesitaProducto() {
        return necesitaProducto;
    }

    public void setNecesitaProducto(boolean necesitaproducto) {
        this.necesitaProducto = necesitaproducto;
    }

    public boolean isRecolectaProducto() {
        return recolectaProducto;
    }

    public void setRecolectaProducto(boolean recolectaProducto) {
        this.recolectaProducto = recolectaProducto;
    }

    public void setIdentificador(Long identificador) {
        this.identificador = identificador;
    }

    public Set<Apero> getAperos() {
        return aperos;
    }

    public void setAperos(Set<Apero> aperos) {
        this.aperos = aperos;
    }

    public Set<Tarea> getTareas() {
        return tareas;
    }

    public void setTareas(Set<Tarea> tareas) {
        this.tareas = tareas;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TipoLabor) {
            if (((TipoLabor) obj).getIdentificador().equals(identificador)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

}