package com.tfg.gestiontareas.model;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity(name = "Cooperativas")
public class UsuarioCooperativa extends Usuario {

    private static final long serialVersionUID = -6190938084916468554L;

    @Column(name = "direccionSede", nullable = false)
    private String direccionSede;

    @Column(name = "numeroTelefono", nullable = true)
    private String numeroTelefono;

    @Column(name = "nombreResponsable", nullable = false)
    private String nombreResponsable;

    @OneToMany(mappedBy = "cooperativa", orphanRemoval = true, fetch = FetchType.EAGER)
    private Set<ProductoCooperativa> productosCooperativas;

    @OneToMany(mappedBy = "cooperativa", orphanRemoval = true, fetch = FetchType.EAGER)
    @JsonIgnore
    private Set<UsuarioAgricultor> socios;

    public UsuarioCooperativa() {
        super();
        setRol(EnumRole.ROLE_RESPONSABLE_COOPERATIVA);
    }

    public String getDireccionSede() {
        return direccionSede;
    }

    public void setDireccionSede(String direccionSede) {
        this.direccionSede = direccionSede;
    }

    public String getNumeroTelefono() {
        return numeroTelefono;
    }

    public void setNumeroTelefono(String numeroTelefono) {
        this.numeroTelefono = numeroTelefono;
    }

    public String getNombreResponsable() {
        return nombreResponsable;
    }

    public void setNombreResponsable(String nombreResponsable) {
        this.nombreResponsable = nombreResponsable;
    }

    public Set<ProductoCooperativa> getProductosCooperativas() {
        return productosCooperativas;
    }

    public void setProductosCooperativas(Set<ProductoCooperativa> productosCooperativas) {
        this.productosCooperativas = productosCooperativas;
    }

    public Set<UsuarioAgricultor> getSocios() {
        return socios;
    }

    public void setSocios(Set<UsuarioAgricultor> socios) {
        this.socios = socios;
    }

    public void registarProductoCooperativa(ProductoCooperativa productoCooperativa) {
        _registarProductoCooperativa(productoCooperativa);
    }

    private void _registarProductoCooperativa(ProductoCooperativa productoCooperativa) {
        productoCooperativa.setCooperativa(this);
    }

}