package com.tfg.gestiontareas.security;

import java.util.Optional;

import com.tfg.gestiontareas.model.Usuario;
import com.tfg.gestiontareas.repository.IRepoUsuario;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

@Service
public class ImpUserDetailService implements UserDetailsService {

    @Autowired
    private IRepoUsuario iRepoUsuario;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        Optional<Usuario> optUsuario = iRepoUsuario.findByUsername(username);
        if (optUsuario.isPresent()) {
            return optUsuario.get();
        } else {
            throw new UsernameNotFoundException(
                    String.format("No se ha encontrado al usaurio con username: %s", username));
        }
    }

}