package com.tfg.gestion_tareas_android.utils;

import android.location.Location;

import com.tfg.gestion_tareas_android.models.Parcela;
import com.tfg.gestion_tareas_android.models.Tarea;

import java.util.Comparator;

public class OrdenarParcelas implements Comparator<Tarea> {

    private Location actual;

    public OrdenarParcelas(Location actual){
        super();
        this.actual = actual;
    }

    @Override
    public int compare(Tarea o1, Tarea o2) {
        Parcela p1 = o1.getParcela();
        Parcela p2 = o2.getParcela();

        if(tieneUbicacion(p1)&&tieneUbicacion(p2)){
            float[] resulta = new float[4];
            double actualLat = actual.getLatitude();
            Location.distanceBetween(actual.getLatitude(),actual.getLongitude(),p1.getCoordLat(),p1.getCoordLong(),resulta);
            float[] resultb = new float[4];
            Location.distanceBetween(actual.getLatitude(),actual.getLongitude(),p2.getCoordLat(),p2.getCoordLong(),resultb);
            return (int)(resulta[0]-resultb[0]);
        }else{
            if(!tieneUbicacion(p1)){
                return Integer.MAX_VALUE;
            }else{
                return Integer.MIN_VALUE;
            }
        }
    }

    private boolean tieneUbicacion(Parcela p){
        return p.getCoordLong() != null && p.getCoordLat()!=null;
    }
}
